<?php
/**
* Joomla Community Builder User Plugin: plug_cbipblock
* @author Caroline Bogart, www.bogartcomputing.com
* @copyright (C) 2011 by Caroline Bogart, www.bogartcomputing.co
* @license Limited  http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );


global $_PLUGINS, $_CB_framework;
$_PLUGINS->registerFunction( 'onDuringLogin', 'login', 'cbIpBlock' );
$_PLUGINS->registerFunction( 'onAfterLogout', 'logout', 'cbIpBlock' );


class cbIpBlock extends cbPluginHandler {
	var $_userid;
	var $_remoteip;

	function setUserId($userid) {
		$this->_userid=$userid;
	}
	function getUserId() {
		return $this->_userid;
	}

	function setRemoteIp($remoteip) {
		$this->_remoteip=$remoteip;
	}
	function getRemoteIp() {
		return $this->_remoteip;
	}

	function login($user, $success) {
		global $_PLUGINS, $_CB_framework, $_CB_database, $mainframe;
		if (!$user) { return;}
		$this->setRemoteIp( getenv('REMOTE_ADDR'));
		$this->setUserId($user->id);
		// remove any ip log references to current IP address. All hits would then be from other IP addresses.
		$query = "DELETE from #__comprofiler_plug_ipblock where userid=".(int)$this->getUserId() . " and userip='" . $this->getRemoteIp() . "'";
		$_CB_database->setQuery($query);
		$_CB_database->query();
		// Are there any current sessions that have the current user id and current IP address?
		$query = "SELECT  distinct(userip) FROM #__comprofiler_plug_ipblock ip, #__session s WHERE ip.userid= ".(int)$this->getUserId()." and ip.userid=s.userid ORDER BY logdate ASC";
		$msg = "";
		$_CB_database->setQuery( $query );
		$ipdata = $_CB_database->loadObjectList();
		$amount = count($ipdata);
		if ($amount>0) { 
			// Yes this user is logged in from another IP
			$i = 0; // counter
			while ($i<=$amount) {
				$ip = $ipdata[$i]->userip;
				$msg .= $ip; // add ip to frontend result
				$i++;
				if ($i<$amount) { $msg .= "<br />"; } 
			}
			// Disallow login, tell user about other sessions.          
			$content["messagesToUser"]="You are also logged in elsewhere. Please log off other sessions before logging in here.<br /><br />You are logged in from:<br />".$msg."<br /><br />";
			$content["alertMessage"]=$content["messagesToUser"];
			$content["showSysMessage"]=$contnet["messagesToUser"];
			$content["stopLogin"]=true;
			$_PLUGINS->_setErrorMSG("Please log off other sessions");
			
			
			return $content;            
		}
		// Record this user's session + IP.
		$this->addUserIp();
			
	}

	function logout($user, $success) {
		global $_PLUGINS, $_CB_framework, $_CB_database, $mainframe;
		$this->setRemoteIp( getenv('REMOTE_ADDR'));
		$this->setUserId($user->id);

		$query = "DELETE from #__comprofiler_plug_ipblock where userid=".(int)$this->getUserId() . " and userip='" . $this->getRemoteIp() . "'";
		$_CB_database->setQuery($query);
	    $_CB_database->query();
	}



	# Add users ip to database!
	function addUserIp() {
		global $_CB_database, $my;
		$logdate = date("y/m/d g:i:s"); // Find current date and time acoording to the server
		$query1="INSERT INTO #__comprofiler_plug_ipblock SET userid=" . $this->getUserId() . ", userip='" . $this->getRemoteIp() . "', logdate='$logdate'";
		$_CB_database->setquery($query1);
		$_CB_database->query();
	}


}	// 
?>
